Subject: [bug#38593] Remove invalid library directories from some haskell packages

From: John Soo <[email-masked]>
Date: Fri, 20 Dec 2019 13:28:52 -0800

Hi Ludo and guix,

Let me explain my problem. Maybe there is some other explanation here and these patches aren’t necessary.

When I have stylish-haskell installed I have troubles compiling anything using plain ghc.   I want to use the ghc packages in the profile but for some reason ghc reports the database is invalid because of at least stylish-haskell and I think I’ve seen hoogle as well.

> Does it hurt in practice, or are these invalid databases shadowed by the
> one created in the profile?

I’m not sure what you mean here. I think I dod not explained my problem well enough. Does the explanation above make sense?

Another possibility is the duplication of path variables in tmux where I usually operate. 

Thinking now, maybe another explanation is because stylish-haskell and ghc-stylish-haskell are fighting each other? They are duplicate packages and maybe if one is removed it will be ok?

> Should we add a phase in ‘haskell-build-system’ that systematically
> removes package databases?

I don’t think so. I like having the profile packages. A lot of times I prefer to use plain ghc with the profile packages over cabal or another tool so I’m happy to have the packages in the database.

The ones I was considering removing were ones that primarily provide a binary to use - hoogle and stylish-haskell are primarily used as binaries.  However on second thought if I wanted to use them as libraries I think I would be confused as to why I could not.

Overall I am leaning towards finding some other solution.

Thanks everyone!

John